package com.example.fuzzControll.controller;

import com.example.fuzzControll.pojo.vo.AjaxResult;
import com.example.fuzzControll.pojo.vo.testEntity;
import com.example.fuzzControll.service.generateMethodService;
import com.example.fuzzControll.service.getServerMessageService;
import com.example.fuzzControll.service.protocolTemplateService;
import com.example.fuzzControll.service.vulnerabilityTypeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

/**
 * 不同类型的测试方法
 */
@RestController
@RequestMapping("/testClass")
public class testClassController {
    @Autowired
    generateMethodService generateMethodService;
    @Autowired
    getServerMessageService getServerMessageService;
    @Autowired
    protocolTemplateService protocolTemplateService;
    @Autowired
    vulnerabilityTypeService vulnerabilityTypeService;
    /**
     * 模板
     */
    @RequestMapping(value = "/protocolTemplate", method = RequestMethod.POST)
    public AjaxResult protocolTemplate(@RequestBody testEntity testEntity) {
        try {
            return AjaxResult.success(protocolTemplateService.generation(testEntity));
        } catch (Exception e) {
            return AjaxResult.error("模板文件生成失败！");
        }
    }

    /**
     *生成方法
     */
    @RequestMapping(value = "/generate", method = RequestMethod.POST)
    public AjaxResult generate(@RequestBody testEntity testEntity) {
        try {
            return AjaxResult.success(generateMethodService.generation(testEntity));
        } catch (Exception e) {
            return AjaxResult.error("变异方法使用失败！");
        }
    }

    /**
     *变异方法
     */
    @RequestMapping(value = "/mutation", method = RequestMethod.POST)
    public AjaxResult mutation() {
        try {
            return AjaxResult.success(getServerMessageService.getStats());
        } catch (Exception e) {
            return AjaxResult.error("mutationTest失败！");
        }
    }

    /**
     *漏洞类型
     */
    @RequestMapping(value = "/vulnerabilityType", method = RequestMethod.POST)
    public AjaxResult upload(@RequestBody testEntity testEntity) {
        try {
            return AjaxResult.success(vulnerabilityTypeService.generation(testEntity));
        } catch (Exception e) {
            return AjaxResult.error("漏洞类型测试失败！");
        }
    }
}
